import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * This is the world Class
 * 
 * @author Ton Tran
 * @version 1
 */
public class MyWorld extends World
{
    private int startX = 0;
    private int startY = 0;
    private int endX = 0;
    private int endY = 0;
    public boolean clicking;
    private GreenfootImage defBG;
    public static Class[] blockType = {Block1.class, Block10.class, Block100.class, Block1000.class};
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(1200, 600, 1); 
        defBG = getBackground();
        prepare();
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        addObject(new AddBlock1(this),1000,40);
        addObject(new AddBlock10(this),750,40);
        addObject(new AddBlock100(this),500,40);
        addObject(new AddBlock1000(this),250,40);
        addObject(new Merge(),900,562);
        addObject(new Split(),1100,562);
        addObject(new Delete(),96,558);
    }

    public void act()
    {
        //System.out.println(Greenfoot.mouseDragEnded(this) + " " + clicking);
        totalValueOfTheCurrentBlocks();
        drawSelection();
    }

    public void drawSelection()
    {
        if (Greenfoot.mousePressed(this) && Greenfoot.getMouseInfo().getActor() == null )
        {
            clicking = true;

            startX = Greenfoot.getMouseInfo().getX();
            startY = Greenfoot.getMouseInfo().getY();
        }
        if (clicking && Greenfoot.getMouseInfo() != null)
        {
            defBG.setColor(Color.WHITE);
            defBG.fill();
            setBackground(defBG);
            //System.out.println(Greenfoot.getMouseInfo().getX());
            GreenfootImage bg = defBG;
            bg.setColor(Color.BLACK);
            if(Greenfoot.getMouseInfo().getX() - startX >= 0 && Greenfoot.getMouseInfo().getY() - startY >= 0)
            {
                bg.drawRect(startX, startY, Greenfoot.getMouseInfo().getX() - startX, Greenfoot.getMouseInfo().getY() - startY);
                endX = Greenfoot.getMouseInfo().getX();
                endY = Greenfoot.getMouseInfo().getY();
            }
            else if (Greenfoot.getMouseInfo().getX() - startX < 0 && Greenfoot.getMouseInfo().getY() - startY >= 0)
            {
                bg.drawRect(Greenfoot.getMouseInfo().getX(), startY, startX - Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY() - startY);
                endX = Greenfoot.getMouseInfo().getX();
                endY = Greenfoot.getMouseInfo().getY();
            }
            else if (Greenfoot.getMouseInfo().getX() - startX < 0 && Greenfoot.getMouseInfo().getY() - startY < 0)
            {
                bg.drawRect(Greenfoot.getMouseInfo().getX(), Greenfoot.getMouseInfo().getY(), startX - Greenfoot.getMouseInfo().getX(), startY  - Greenfoot.getMouseInfo().getY());
                endX = Greenfoot.getMouseInfo().getX();
                endY = Greenfoot.getMouseInfo().getY();
            }
            else 
            {
                bg.drawRect(startX, Greenfoot.getMouseInfo().getY(), Greenfoot.getMouseInfo().getX() - startX, startY  - Greenfoot.getMouseInfo().getY());
                endX = Greenfoot.getMouseInfo().getX();
                endY = Greenfoot.getMouseInfo().getY();
            }
            setBackground(bg);
        }
        if (Greenfoot.mouseDragEnded(this))
        {
            clicking = false;
        }
    }

    public ArrayList<Block> selectedBlocks()
    {
        int xOne = -1;
        int yOne = -1;
        int xTwo = -1;
        int yTwo = -1;
        ArrayList array = new ArrayList<Block>();
        if (Greenfoot.getMouseInfo() != null)
        {
            if(endX - startX > 0 && endY - startY > 0)
            {
                xOne = startX;
                yOne = startY;
                xTwo = endX;
                yTwo = endY;
            }
            else if (endX - startX < 0 && endY - startY >= 0)
            {
                xOne = endX;
                yOne = startY;
                xTwo = startX;
                yTwo = endY;
            }
            else if (endX - startX < 0 && endY - startY < 0)
            {
                xOne = endX;
                yOne = endY;
                xTwo = startX;
                yTwo = startY;
            }
            else 
            {
                xOne = startX;
                yOne = endY;
                xTwo = endX;
                yTwo = startY;
            }
        }
        for (Block currentBlock : getObjects(Block.class)) {
            if (xOne < currentBlock.getX() && currentBlock.getX() < xTwo && yOne < currentBlock.getY() && yTwo > currentBlock.getY()) 
            {
                array.add(currentBlock);
            }

        }
        return array;
    }

    public void totalValueOfTheCurrentBlocks()
    {
        ArrayList<Block> array = new ArrayList(getObjects(Block.class));
        int totalValue = 0;
        for(int i = 0; i < getObjects(Block.class).size(); i++)
        {
            totalValue += array.get(i).value;
        }
        showText(String.valueOf(totalValue), 600, 550);
    }
}
