import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * This class takes in Generic type of "Block" to split them
 * 
 * @author Ton Tran 
 * @version 1
 */
public class Split extends Actor
{
    private boolean mousePressed = false;
    /**
     * Act - do whatever the Split wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if (Greenfoot.mouseClicked(this) && getWorldOfType(MyWorld.class).clicking)
        {
            getWorldOfType(MyWorld.class).clicking = false;
        }
        if (Greenfoot.mousePressed(this))
        {
            split();
        }
    }

    /**
     * split takes one block to "split" them into smaller values.
     */
    public void split()
    {
        ArrayList<Block> array = getWorldOfType(MyWorld.class).selectedBlocks();
        for (int i = 0; i < array.size(); i++)
        {
            Block parent = array.get(i);
            if (parent.value != 1)
            {
                for (int b = 0 ; b < 10; b++)
                {
                    switch (parent.value) {
                        case 10:
                            getWorldOfType(MyWorld.class).addObject(new Block1(), parent.getX() + b * 21, parent.getY());
                            break;
                        case 100:
                            getWorldOfType(MyWorld.class).addObject(new Block10(), parent.getX() + b * 21, parent.getY());
                            break;
                        case 1000:
                            getWorldOfType(MyWorld.class).addObject(new Block100(), parent.getX() + b * 101, parent.getY());
                            break;
                    } 
                }
                getWorldOfType(MyWorld.class).removeObject(parent);
            }
        }
    }
}
